/*
 * Copyright (C) 1999  Piero Fariselli
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 * contacts: Piero Fariselli
 *           e-mail: piero@biocomp.unibo.it, farisel@alma.unibo.it
 *           Dept. of Biology
 *           University of Bologna
 *           via Irnerio 42
 *           40126 Bologna
 *           Italy
 */
/** Class which implement the concept of protein sequence
it has 4 private variables
1. Sequence Name
2. sequence 
3. secondary structure labels
4. sequence length
*/

#include <stdio.h> 
//#include <iostream.h> 
#include <iostream> 
#include <string.h> 
#include <math.h> 


class Sequence {
   private:
        char * name;  // name
        char * seq;   // sequence
        char * SS;    // secondary structure labels
        int len;      // length

// Class builders

   public:
   /** empty */
   Sequence() ;
   /** only sequence  */
   Sequence(char * seq) ;
   /** sequence and name */
   Sequence(char * name, char * seq) ;      
   /** everything */
   Sequence(char * name, char * seq, char * SS) ;      

   ~Sequence();
   
// Other methods

   
   void setSequenceName(char * name) ;
   void setSequence(char * seq) ;
   void setSequence(char * name, char * seq) ;
   void setSequence(char * name, char * seq, char * SS) ;
   void cpSequence(Sequence s) ;
   char * getSequence () ;
   char * getStringSS () ;
   int getLengthSS () ;
   char * getName() ;
   int getLen() ;
   char charAt(int i) ;
   char ssAt(int i) ;
   Sequence cleanSequence() ;
   Sequence  cleanSequenceRes() ;
// print functions

   void printSequence() ;
   void printSequence(int max) ;
   void printSequenceAll() ;
};
// End class Sequence
// ********************************* //
